src/main/java/com/br/mvsistemas/sysvendas/model/PlanoContas.java
package com.br.mvsistemas.sysvendas.model;

import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import lombok.Getter;
import lombok.Setter;

@Entity
@Table(name = "plano_contas")
public class PlanoContas implements Entidade{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 2122198393620525125L;
	
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "id_plano_contas")
	private Long id;
	
	@Getter
	@Setter
	private String codigo;
	
	@Getter
	@Setter
	private String descricao;
	
	@Getter
	@Setter
	@Column(name = "descricao_completa")
	private String descricaoCompleta;
	
	@Getter
	@Setter
	private boolean titulo;
	
	@Getter
	@Setter
	@Column(name = "id_sub_plano_conta")
	private Long idSuPlanoContas;
	
	@Getter
	@Setter
	@Enumerated(EnumType.STRING)
	@Column(name = "receita_despesa", nullable = false, length=1)
	private TipoPlanoContas receitaDespesa;
	
	@Override
	public Long getId() {
		return id;
	}

	@Override
	public void setId(Long id) {
		this.id = id;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		PlanoContas other = (PlanoContas) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}
}

src/main/java/com/br/mvsistemas/sysvendas/controller/PlanoContasController.java
package com.br.mvsistemas.sysvendas.controller;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.PostConstruct;
import javax.faces.context.FacesContext;
import javax.faces.view.ViewScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.primefaces.context.RequestContext;
import org.primefaces.model.DefaultTreeNode;
import org.primefaces.model.TreeNode;

import com.br.mvsistemas.sysvendas.model.PlanoContas;
import com.br.mvsistemas.sysvendas.model.TipoPlanoContas;
import com.br.mvsistemas.sysvendas.model.TipoProdutoEnum;
import com.br.mvsistemas.sysvendas.model.Usuario;
import com.br.mvsistemas.sysvendas.service.PlanoContasService;
import com.br.mvsistemas.sysvendas.util.FacesMessages;

import lombok.Getter;
import lombok.Setter;

@Named
@ViewScoped
public class PlanoContasController implements Serializable {

	private static final long serialVersionUID = 8476820186553944604L;

	@Inject
	private PlanoContasService planoContasService;

	@Inject
	private FacesMessages mensagem;

	@Getter
	@Setter
	private TreeNode root;

	private TreeNode selectedNode;

	@Getter
	@Setter
	private List<PlanoContas> liste;

	@Getter
	@Setter
	private List<PlanoContas> altListe;

	@Getter
	@Setter
	private List<PlanoContas> altListe2;

	@Getter
	@Setter
	private PlanoContas planoContasSelecionado;
	
	@Getter
	@Setter
	private PlanoContas planoContas;

	@PostConstruct
	public void consultar() {
		this.root = new DefaultTreeNode("Raiz", null);
		liste = new ArrayList<>();
		liste = planoContasService.todos();
		recursive(liste, 0l, root);
		planoContas = new PlanoContas();
	}

	public void recursive(List<PlanoContas> liste, Long id, TreeNode node) {
		altListe2 = new ArrayList<PlanoContas>();
		altListe2 = altKategorileriGetir(id);
		for (PlanoContas c : altListe2) {

			TreeNode childNode = new DefaultTreeNode(c.getDescricaoCompleta(), node);
			recursive(altListe2, c.getId(), childNode);
		}
	}

	public List<PlanoContas> altKategorileriGetir(Long i) {
		altListe = new ArrayList<PlanoContas>();
		for (PlanoContas c : getListe()) {
			if (c.getIdSuPlanoContas() == i) {
				altListe.add(c);
			}
		}
		return altListe;
	}

	public void testeDeSelecionar() {
		if (selectedNode != null) {
			FacesContext.getCurrentInstance().getExternalContext().getSessionMap().put("planoContasSelecionado", planoContasService.planoContas(selectedNode.getData().toString()));
			
		}
		
		Map<String,Object> options = new HashMap<String, Object>();
        options.put("modal", true);
        options.put("width", 350);
        options.put("height", 260);
        options.put("resizable", false);
        options.put("draggable", false);
//        options.put("contentWidth", "100%");
//        options.put("contentHeight", "100%");
        options.put("id", "dlgNovoPlano");
         
        RequestContext.getCurrentInstance().openDialog("/planoconta/viewNewPlanoContas", options, null);
        
        
	}  
	
	public TreeNode getSelectedNode() {
		return selectedNode;
	}
	
	public void setSelectedNode(TreeNode selectedNode) {
		this.selectedNode = selectedNode;
	}
	
	
	public void mostrarDescricaoPlano(){
		planoContasSelecionado = (PlanoContas) FacesContext.getCurrentInstance().getExternalContext().getSessionMap()
				.get("planoContasSelecionado");
		
		//mensagem.info("Plano Selecionado: "+planoContasSelecionado.getDescricao());
	}
	
	public void salvar(){
		planoContasSelecionado = (PlanoContas) FacesContext.getCurrentInstance().getExternalContext().getSessionMap()
				.get("planoContasSelecionado");
		planoContas.setCodigo(planoContasSelecionado.getCodigo()+'.'+planoContas.getCodigo());
	}
	
	public TipoPlanoContas[] getTipoPlanoContas(){
		return TipoPlanoContas.values();
	}
}

src/main/webapp/planoconta/index.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:p="http://primefaces.org/ui"
	xmlns:h="http://xmlns.jcp.org/jsf/html"
	xmlns:fn="http://java.sun.com/jsp/jstl/functions"
	xmlns:f="http://java.sun.com/jsf/core">

<ui:composition>
	<h1>
		<small>Plano de Contas</small>
	</h1>
	<h:form id="frm">
            <p:tree id="docs" value="#{planoContasController.root}" 
					var="plano" selectionMode="single"
					selection="#{planoContasController.selectedNode}">
				<p:treeNode>
					<h:outputText value="#{plano}" />
				</p:treeNode>
			</p:tree>

			<p:contextMenu for="docs">
				<p:menuitem value="Novo" update="@none"
					actionListener="#{planoContasController.testeDeSelecionar}"
					icon="ui-icon-search"/>
				<p:menuitem value="Delete" update="docs"
					actionListener="#{treeContextMenuView.deleteNode}"
					icon="ui-icon-close" />
			</p:contextMenu>
	</h:form>
</ui:composition>

</html>

src/main/webapp/planoconta/viewNewPlanoContas.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:p="http://primefaces.org/ui"
	xmlns:h="http://xmlns.jcp.org/jsf/html"
	xmlns:fn="http://java.sun.com/jsp/jstl/functions"
	xmlns:f="http://java.sun.com/jsf/core">

<h:head>
	<title>Novo Plano de Contas</title>
	<style type="text/css">
.ui-widget {
	font-size: 90%;
}
</style>
<h:outputStylesheet library="css" name="sistema.css" />
<h:outputStylesheet library="bootstrap" name="css/bootstrap.min.css" />
</h:head>

<h:body>

	<h:form id="frmPlano">
		<p:panelGrid columns="1" id="panel-plano" styleClass="semBorda">
		<p:messages id="messages" autoUpdate="true" closable="true" />
			<p:inputText placeholder="Nivel" value="#{planoContasController.planoContas.codigo}"/>
			<p:inputText placeholder="Texto" value="#{planoContasController.planoContas.descricao}"/>
			<p:selectBooleanCheckbox itemLabel="Titulo ?" value="#{planoContasController.planoContas.titulo}"/>
			<p:selectOneMenu value="#{planoContasController.planoContas.receitaDespesa}" 
						maxlength="10" autoWidth="true" style="width:150px;">
				<f:selectItems value="#{planoContasController.tipoPlanoContas}"
					var="tipos" itemLabel="#{tipos.descricao}" itemValue="#{tipos}" />
			</p:selectOneMenu>
			<p:commandButton title="Clicar" actionListener="#{planoContasController.mostrarDescricaoPlano}" update=":frmPlano:messages"/>
		</p:panelGrid>
	</h:form>
</h:body>

</html>